<?php 
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined('_VALID_MOS') or die('Direct Access to this location is not allowed.');

// ensure user has access to this function
if(!($acl->acl_check('administration', 'edit', 'users', $my->usertype, 'components', 'all') | $acl->acl_check('administration', 'edit', 'users', $my->usertype, 'components', 'com_pms')))
{
	mosRedirect( 'index2.php', _NOT_AUTH );
}

define('PMS_BASEPATH_COMPONENTS', dirname(__FILE__).'/../../../components/com_pms');
define('PMS_BASEPATH_ADMINISTRATOR', dirname(__FILE__));

require_once($mainframe->getPath('admin_html'));
require_once(PMS_BASEPATH_COMPONENTS . '/functions.php');
require_once(PMS_BASEPATH_ADMINISTRATOR . '/backend_authentification.php');
?>
<script language="JavaScript" src="../components/com_pms/functions.js" type="text/javascript"></script>

<?php
// get the right language if it exists
if(file_exists(PMS_BASEPATH_ADMINISTRATOR.'/language/'.$mosConfig_lang.'.php')) include_once(PMS_BASEPATH_ADMINISTRATOR.'/language/'.$mosConfig_lang.'.php');
else include_once(PMS_BASEPATH_ADMINISTRATOR.'/language/english.php');

$my_id = $my->id;
$my_gid = $my->gid;
$pmid  = mosGetParam( $_REQUEST, 'pmid', array( 0 ) );
if (!is_array( $pmid )) {
 $pmid = array ( 0 );
}
$is_admin = false;
if(in_array($my_id, $allowed_user_ids, true) AND in_array($my_gid, $allowed_group_ids, true)) $is_admin = true;

$url_components_images = "../components/com_pms/images/";
$url_administrator_images = "components/com_pms/images/";

switch($act)
{
	case "config":
	switch($task)
	{
		case "save":
		saveConfiguration($option);
		break;
		
		case "cancel":
		listConfiguration($option);
		break;

		default:
		listConfiguration($option);
		break;
	}
	break;
	
	case "view_edit":
	switch($task)
	{
		case "new":
		edit_newPM($option, 0);
		break;
		
		case "edit":
		edit_newPM($option, $pmid[0]);
		break;
		
		case "remove":
		removePM($option, $pmid);
		break;
		
		case "save":
		savePM($option);
		break;
		
		case "cancel":
		listPMs($option, 1);
		break;
		
		default:
		listPMs($option, 0);
		break;
	}
	break;

	case "about":
	showFormular();
	break;
}

function showFormular()
{
	if(mosGetParam($_POST, 'about_name'))	
	{
		global $mosConfig_live_site;
		
		$msg = "Name: ".mosGetParam($_POST, 'about_name')."\r\n";
		$msg .= "Kontakt: ".mosGetParam($_POST, 'about_mail')."\r\n";
		$msg .= "Betreff: ".mosGetParam($_POST, 'about_subject')."\r\n";
		$msg .= "Nachricht: ".mosGetParam($_POST, 'about_message')."\r\n";
		$msg .= "von der Seite: ".$mosConfig_live_site."\r\n";
		$msg .= "PMS enhanced Version: 2.0.4\r\n";

		$head = "From:\"".$mosConfig_live_site."\" <".mosGetParam($_POST, 'about_mail').">\n";
		$head .= "Content-Type: text/plain\nContent-Transfer-Encoding: quoted-printable\n";

		if(mail('pms@stefan-klingner.de', mosGetParam($_POST, 'about_subject'), $msg, $head)) mosRedirect('index2.php?option=com_pms&act=about&mosmsg='._PMS_MSG_ABOUT_SENT_OK);
		else mosRedirect('index2.php?option=com_pms&act=about&mosmsg='._PMS_MSG_ABOUT_SENT_ERROR);
	}
	HTML_pms::about();
}

function saveConfiguration($option)
{
	global $database;
	$values_in_file = array();
	$values_in_db = array();
	$error_db = false;
	$error_file = false;
	foreach($_POST AS $key=>$value)
	{
		if(is_array($value) AND substr($key, 0, 5)=="file_") $value="\"".implode(",", $value)."\"";
		else if(is_array($value) AND substr($key, 0, 3)=="db_") $value=implode(",", $value);
		if(substr($key, 0, 3)=="db_") $values_in_db[] = substr($key, 3)."=".$value;
		else if(substr($key, 0, 5)=="file_") $values_in_file[substr($key, 5)] = $value;
	}
	
	//store db-values in db
	$query = "UPDATE #__pms_conf SET ".implode(",", $values_in_db)." WHERE user_id=0";
	$database->setQuery($query);
	if(!$database->query())
	{
		pms_sql_error($database->getErrorMsg());
		$error_db = true;
	}
	
	//store file-values in file
	$configfile = "components/com_pms/config.pms.php";
	if(!is_writable($configfile)) $error_file = true;
	else
	{
		$txt = "<?php\n";
		foreach($values_in_file AS $key=>$value) $txt .= "\$$key=$value;\n";
		$txt .= "?>";
		if($fp = fopen($configfile, "w"))
		{
			fputs($fp, $txt, strlen($txt));
			fclose ($fp);
		}
		else $error_file = true;
	}
	if($error_db AND $error_file) $mosmsg = _PMS_MSG_SAVE_SETTINGS_ERROR;
	else if($error_db) $mosmsg = _PMS_MSG_SAVE_SETTINGS_FILE;
	else if($error_file) $mosmsg = _PMS_MSG_SAVE_SETTINGS_DB;
	else $mosmsg = _PMS_MSG_SAVE_SETTINGS_ALL;
	mosRedirect("index2.php?option=$option&act=config", $mosmsg);
}

function listConfiguration($option)
{
	global $database, $acl;
	
	require_once(PMS_BASEPATH_ADMINISTRATOR . '/config.pms.php');
	
	$group_tree = array();
	$group_tree = array_merge($group_tree, $acl->get_group_children_tree(null, 'USERS', false));

	$usergids = explode(",",$usergroupids);
	$usergids_values = array();
	foreach($usergids as $usergid) $usergids_values[]->value=$usergid;

	$usergroups_list = mosHTML::selectList($group_tree, 'file_usergroupids[]', 'size="9" multiple', 'value', 'text', $usergids_values, 1);
	
	$database->setQuery("SELECT * FROM #__pms_conf WHERE id=1");
	if(!$database->query())
	{
		pms_sql_error($database->getErrorMsg());
		return false;
	}
	$rows = $database->loadObjectList();
	HTML_pms::listConfiguration($option, $rows, $usergroups_list);
}

function listPMs($option, $cancel)
{
	global $database, $is_admin;
	
	$filter_values = array("", "", "", "", "", "", -9, -9, -9);
	$sql_where = array();
	
	if($cancel==0)
	{
		// get parameter from filter
		if(mosGetParam($_POST, 'sender'))
		{
			$filter_values[0] = intval(mosGetParam($_POST, 'sender'));
			if($filter_values[0]!="") $sql_where[] = "t1.sender_id=$filter_values[0]";
		}
		if(mosGetParam($_POST, 'recip'))
		{
			$filter_values[1] = intval(mosGetParam($_POST, 'recip'));
			if($filter_values[1]!="") $sql_where[] = "t1.recip_id=$filter_values[1]";
		}
		if(mosGetParam($_POST, 'date_start'))
		{
			$filter_values[2] = $database->getEscaped(mosGetParam($_POST, 'date_start'));
			if($filter_values[2]!="")
			{
				$tmp = explode(".", $filter_values[2]);
				$tmp_new = $tmp[2]."-".$tmp[1]."-".$tmp[0];
				$sql_where[] = "t1.date>='$tmp_new'";
			}
		}
		if(mosGetParam($_POST, 'date_end'))
		{
			$filter_values[3] = $database->getEscaped(mosGetParam($_POST, 'date_end'));
			if($filter_values[3]!="")
			{
				$tmp = explode(".", $filter_values[3]);
				$tmp_new = $tmp[2]."-".$tmp[1]."-".$tmp[0];
				$sql_where[] = "t1.date<='$tmp_new'";
			}
		}
		if(mosGetParam($_POST, 'subject'))
		{
			$filter_values[4] = $database->getEscaped(mosGetParam($_POST, 'subject'));
			if($filter_values[4]!="")
			{
				$tmp = explode(" ", $filter_values[4]);
				foreach($tmp as $word) $sql_where[] = "t1.subject LIKE '%$word%'";
			}
		}
		if(mosGetParam($_POST, 'message'))
		{
			$filter_values[5] = $database->getEscaped(mosGetParam($_POST, 'message'));
			if($filter_values[5]!="")
			{
				$tmp = explode(" ", $filter_values[5]);
				foreach($tmp as $word) $sql_where[] = "t1.message LIKE '%$word%'";
			}
		}
		if(mosGetParam($_POST, 'status'))
		{
			$filter_values[6] = intval(mosGetParam($_POST, 'status'));
			if($filter_values[6]!=-9) $sql_where[] = "t1.readstate=$filter_values[6]";
		}
		if(mosGetParam($_POST, 'inbox'))
		{
			$filter_values[7] = intval(mosGetParam($_POST, 'inbox'));
			if($filter_values[7]!=-9) $sql_where[] = "t1.inbox=$filter_values[7]";
		}
		if(mosGetParam($_POST, 'sent_items'))
		{
			$filter_values[8] = intval(mosGetParam($_POST, 'sent_items'));
			if($filter_values[8]!=-9) $sql_where[] = "t1.sent_items=$filter_values[8]";
		}
	}

	$limit = intval(mosGetParam($_POST, 'limit', 10));
	$limitstart = intval(mosGetParam($_POST, 'limitstart', 0));
	
	// get the total number of records including filter parameters
	$database->setQuery("SELECT count(t1.id) FROM #__pms AS t1".(count($sql_where) ? " WHERE " . implode(' AND ', $sql_where) : ""));
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$total = $database->loadResult();
	
	$sql_where[] = "t2.id = t1.sender_id";
	$sql_where[] = "t3.id = t1.recip_id";
	
	$database->setQuery("SELECT t1.id, DATE_FORMAT(t1.date, '%d.%m.%Y') AS date, t1.time, t1.readstate, t1.subject, t1.message, t1.inbox, t1.sent_items, t2.username AS sender_username, t2.name AS sender_name, t3.username AS recip_username, t3.name AS recip_name FROM #__pms AS t1, #__users AS t2, #__users AS t3 WHERE ".implode(' AND ', $sql_where)." ORDER BY t1.date DESC, t1.time DESC LIMIT $limitstart, $limit");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$rows = $database->loadObjectList();
	
	require_once(PMS_BASEPATH_ADMINISTRATOR . '/../../includes/pageNavigation.php');
	$pageNav = new mosPageNav($total, $limitstart, $limit);
	
	HTML_pms::showPMs($option, $rows, $pageNav, $filter_values, $is_admin);
}

function edit_newPM($option, $pmid)
{
	global $database, $is_admin;
	
	$row = array();
	$pmid = intval($pmid);
	if($pmid AND $is_admin)
	{
		$database->setQuery("SELECT id, sender_id, recip_id, subject, message, readstate, inbox, sent_items, DATE_FORMAT(date, '%d.%m.%Y') AS date, time FROM #__pms WHERE id = $pmid");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$rows = $database->loadObjectList();
		$row = $rows[0];
	}
	else if(!$pmid) $is_admin = true;
	HTML_pms::edit_newPM($option, $row, $is_admin);
}

function removePM($option, &$pmid)
{
	global $database;
	
	if(count($pmid))
	{
		$pmids = implode( ',', $pmid );
		$pmids = $database->getEscaped($pmids);
		$database->setQuery("DELETE FROM #__pms WHERE id IN ($pmids)");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
	}
	mosRedirect("index2.php?option=$option&act=view_edit");
}

function savePM($option)
{
	global $database;
	
	$id = intval(mosGetParam($_POST, 'id'));
	$error = false;
	
	if($id=="")
	{
		$values = array();
		foreach ($_POST AS $key=>$value)
		{
			if(substr($key, 0, 3)=="db_")
			{
				if($key=="db_subject" AND !ereg("[^\x01-\x20]", $value)) $value = _PMS_NO_SUBJECT;
				$values[] = "'".$value."'";
			}
		}
		$query = "INSERT INTO #__pms (sender_id, recip_id, subject, message, readstate, sent_items, inbox, date, time) VALUES (".implode(",", $values).")";
	}
	else
	{
		$set = array();
		foreach ($_POST AS $key=>$value)
		{
			if(substr($key, 0, 3)=="db_")
			{
				if($key=="db_subject" AND !ereg("[^\x01-\x20]", $value)) $value = _PMS_NO_SUBJECT;
				$set[] = substr($key, 3)."='".$value."'";
			}
		}
		$query = "UPDATE #__pms SET ".implode(",", $set)." WHERE id=$id";
	}
	
	$database->setQuery($query);
	if(!$database->query())
	{
		pms_sql_error($database->getErrorMsg());
		$error = true;
	}
	
	$database->setQuery("DELETE FROM #__pms WHERE inbox=-1 AND sent_items=-1");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	if($id=="")
	{
		if($error) mosRedirect("index2.php?option=$option&act=view_edit", _PMS_MSG_SAVE_NEW_ERROR);
		else mosRedirect("index2.php?option=$option&act=view_edit", _PMS_MSG_SAVE_NEW);
	}
	else
	{
		if($error) mosRedirect("index2.php?option=$option&act=view_edit", _PMS_MSG_SAVE_UPDATE_ERROR);
		else mosRedirect("index2.php?option=$option&act=view_edit", _PMS_MSG_SAVE_UPDATE);
	}
}
?>