<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

function pms_writePagesLinks($limitstart, $limit, $total)
{
	global $pages_in_list;
	
	if($pages_in_list<1) $pages_in_list = 1;
	$total_pages = ceil($total / $limit);
	$this_page = ceil(($limitstart + 1) / $limit);
	$start_loop = (floor(($this_page - 1) / $pages_in_list)) * $pages_in_list + 1;
	if($start_loop + $pages_in_list - 1<$total_pages) $stop_loop = $start_loop + $pages_in_list - 1;
	else $stop_loop = $total_pages;
	if($this_page>1)
	{
		$page = ($this_page - 2) * $limit;
		echo '&nbsp;<a style="cursor:pointer" title="'._PMS_FIRST_PAGE.'" onClick="pms_list_page_navigation(0)"><<</a>&nbsp;';
		echo '<a style="cursor:pointer" title="'._PMS_PREV_PAGE.'" onClick="pms_list_page_navigation('.$page.')"><</a>';
	}
	for($i = $start_loop; $i<=$stop_loop; $i++)
	{
		$page = ($i - 1) * $limit;
		if($i==$this_page) echo "&nbsp;<b>$i</b>";
		else echo '&nbsp;<a style="cursor:pointer" title="'._PMS_PAGE.' '.$i.'" onClick="pms_list_page_navigation('.$page.')">'.$i.'</a>';
	}
	if($this_page<$total_pages)
	{
		$page = $this_page * $limit;
		$end_page = ($total_pages - 1) * $limit;
		echo '&nbsp;<a style="cursor:pointer" onClick="pms_list_page_navigation('.$page.')" title="'._PMS_NEXT_PAGE.'">></a>';
		echo '&nbsp;<a style="cursor:pointer" onClick="pms_list_page_navigation('.$end_page.')" title="'._PMS_END_PAGE.'">>></a>';
	}
}

function pms_writePagesCounter($limitstart, $limit, $total)
{
	$from_result = $limitstart+1;
	if($limitstart + $limit<$total) $to_result = $limitstart + $limit;
	else $to_result = $total;
	if($total>0) echo _PMS_RESULTS."&nbsp;<b>".$from_result."&nbsp;-&nbsp;".$to_result."</b>&nbsp;"._PMS_OF_TOTAL."&nbsp;<b>".$total."</b>";
	else echo _PMS_NO_RESULTS.".";
}

function pms_parse($message)
{
	global $bb_code, $smiley, $mosConfig_live_site, $url_components, $format_reply;

	if(!get_magic_quotes_gpc()) $message = stripslashes($message);
	
	// Convert BB Code to HTML commands
	if($bb_code==1)
	{
		$matchCount = preg_match_all("#\[code\](.*?)\[/code\]#si", $message, $matches);
		for($i = 0; $i<$matchCount; $i++)
		{
			$currMatchTextBefore = preg_quote($matches[1][$i]);
			$currMatchTextAfter = htmlspecialchars($matches[1][$i]);
			$message = preg_replace("#\[code\]$currMatchTextBefore\[/code\]#si", "<b>Code:</b><hr>$currMatchTextAfter<hr>", $message);
		}
		$message = preg_replace("#\[quote\](.*?)\[/quote]#si", "<b>Quote:</b><hr><blockquote>\\1</blockquote><hr>", $message);
		$message = preg_replace("#\[b\](.*?)\[/b\]#si", "<b>\\1</b>", $message);
		$message = preg_replace("#\[i\](.*?)\[/i\]#si", "<i>\\1</i>", $message);
		$message = preg_replace("#\[u\](.*?)\[/u\]#si", "<u>\\1</u>", $message);
		$message = preg_replace("#\[url\](http://)?(.*?)\[/url\]#si", "<a href=\"http://\\2\" target=\"_blank\">\\2</a>", $message);
		$message = preg_replace("#\[email\](.*?)\[/email\]#si", "<a href=\"mailto:\\1\">\\1</a>", $message);
	}

	// for italic Reply if bb-code is disabled
	if($format_reply==2) $message = preg_replace("#\[i\](.*?)\[/i\]#si", "<i>\\1</i>", $message);

	// Convert CR and LF to HTML <br /> command
	$message = preg_replace("/(\015\012)|(\015)|(\012)/","&nbsp;<br />", $message);

	// Convert smilies to images
	if($smiley==1)
	{
		$smiley_array = pms_create_smiley_array();
		
		foreach($smiley_array AS $smiley_description => $smiley_files)
		{
			$message = str_replace("$smiley_description", "<img src=\"components/com_pms/images/smiley/$smiley_files\" border=\"0\" alt=\"$smiley_description\" title=\"$smiley_description\" />", $message);
		}
	}
	return $message;
}

function pms_prefix($subject, $prefix)
{
	//check for prefixes from older versions
	if(substr($subject, 0, strlen($prefix))==$prefix)
	{
		$count_old_prefix = 1;
		while(substr($subject, 0, strlen($prefix))==$prefix)
		{
			$subject = substr($subject, strlen($prefix) + 1);
			$count_old_prefix++;
		}
	}
	
	if(substr($subject, 0, strlen($prefix) + 1)=="[".$prefix)
	{
		$pos_end_prefix = strpos($subject, "]");
		$counter = substr($subject, strlen($prefix) + 2, $pos_end_prefix-strlen($prefix) - 2);
		$counter++;
		$subject = "[".$prefix."&nbsp;".$counter."]&nbsp;".ltrim(substr($subject, $pos_end_prefix + 2));
	}
	else
	{
		if(!isset($count_old_prefix)) $subject = "[".$prefix."&nbsp;1]&nbsp;".$subject;
		else $subject = "[".$prefix."&nbsp;".$count_old_prefix."]&nbsp;".$subject;
	}
	return $subject;
}

function pms_create_smiley_array()
{
	global $mosConfig_absolute_path;
	
	// read of available smiley files
	$handle = opendir(PMS_BASEPATH_COMPONENTS . '/images/smiley/');
	while($file = readdir($handle))
	{
		if($file != "." && $file != "..")
		{
			$extension = substr($file, strlen($file)-3);
			if($extension=="gif" OR $extension=="png" OR $extension=="jpg") $smiley_files[] = $file;
		}
	}
	
	// set smiley description and replace with default tags
	$smiley_tags = array("8)" => "cool.gif", ":)" => "smile.gif", ":P" => "tongue.gif", ";)" => "wink.gif");
	foreach($smiley_files AS $smiley_file)
	{
		if(array_search($smiley_file, $smiley_tags)!=NULL)
		{
			$smiley_description[] = array_search($smiley_file, $smiley_tags);
		}
		else
		{
			$pos_extension = strrpos($smiley_file, ".");
			$file_name = substr($smiley_file, 0, $pos_extension);
			$smiley_description[] = ":".$file_name.":";
		}
	}
	
	// create smiley array with keys and values
	for($i=0; $i<count($smiley_files); $i++)
	{
		$smiley_array[$smiley_description[$i]] = $smiley_files[$i];
	}
	
	return $smiley_array;
}

// output as JS-alert if SQL query fails
function pms_sql_error($error)
{
	echo "<script>alert('".$error."');</script>";
}
?>