<?php
###################################################################
## Title........: PMS enhanced
###################################################################
## Description..: A Private Messaging System (PMS) for Mambo/Joomla
## Author.......: Stefan Klingner (original Danial Taherzadeh)
## Version......: 2.0.4
## Created......: 22.02.2007
## Contact......: pms@stefan-klingner.de
## License......: GNU/GPL (based on PMS OpenSource from april 2005)
## Note.........: This script is part of the PMS enhanced package
###################################################################

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

define('PMS_BASEPATH_COMPONENTS', dirname(__FILE__));
define('PMS_BASEPATH_ADMINISTRATOR', dirname(__FILE__).'/../../administrator/components/com_pms');

global $database, $mainframe;

$my_id = intval($my->id);

// check for not registered users
if(!$my_id) echo _NOT_AUTH;
else
{
	require_once(PMS_BASEPATH_COMPONENTS . '/functions.php');
	require_once(PMS_BASEPATH_ADMINISTRATOR . '/config.pms.php');
	$mosmsg = "";
	
	$database->setQuery("SELECT session_id FROM #__session WHERE userid=$my_id LIMIT 1");
	$session_id = $database->loadResult();

	// get the right language if it exists
	if(file_exists(PMS_BASEPATH_ADMINISTRATOR.'/language/'.$mosConfig_lang.'.php')) include_once(PMS_BASEPATH_ADMINISTRATOR.'/language/'.$mosConfig_lang.'.php');
	else include_once(PMS_BASEPATH_ADMINISTRATOR.'/language/english.php');

	// description for readstate icons
	$readstate_img_alt[0] = _PMS_PM_UNREAD;
	$readstate_img_alt[1] = _PMS_PM_READ;
	$readstate_img_alt[2] = _PMS_PM_REPLY_UNREAD;
	$readstate_img_alt[3] = _PMS_PM_REPLY_READ;
	$readstate_img_alt[4] = _PMS_PM_FORWARD_UNREAD;
	$readstate_img_alt[5] = _PMS_PM_FORWARD_READ;
	$readstate_img_alt[6] = _PMS_PM_REPLY_FORWARD_UNREAD;
	$readstate_img_alt[7] = _PMS_PM_REPLY_FORWARD_READ;
	
	// get menu-id for PMS-component
	$database->setQuery("SELECT id FROM #__menu WHERE link='index.php?option=com_pms' AND type='components' AND published>=1 LIMIT 1");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$pms_menuid = $database->loadResult();
	
	// get menu-id for CB-component
	if($cb_version>0)
	{
		$database->setQuery("SELECT id FROM #__menu WHERE link='index.php?option=com_comprofiler' AND type='components' AND published>=1 LIMIT 1");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$cb_menuid = $database->loadResult();
	}
	
	// get default configuration from database
	$database->setQuery("SELECT * FROM #__pms_conf WHERE user_id=0");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$rows = $database->loadObjectList();
	$row = $rows[0];
	$email_new = $row->email_new;
	$email_reply = $row->email_reply;
	$email_html = $row->email_html;
	$email_offline = $row->email_offline;
	$email_sender_address = $row->email_sender_address;
	$rows_per_page = $row->rows_per_page;
	$pages_in_list = $row->pages_in_list;
	$format_reply = $row->format_reply;
	$clear_sent_items = $row->clear_sent_items;
	$popup = $row->popup;
	$sound = $row->sound;
	$sound_value = $row->sound_value;
	
	// check if usersettings are enabled
	$user_settings = 0;
	if($allow_change_email_new==1 OR $allow_change_email_reply==1 OR $allow_change_email_html==1 OR $allow_change_email_offline==1 OR $allow_change_email_sender_address==1 OR $allow_change_format_reply==1 OR $clear_sent_items==1 OR $allow_change_popup==1 OR $allow_change_sound==1 OR $allow_change_sound_value OR $allow_change_rows_per_page==1 OR $allow_change_pages_in_list==1) $user_settings = 1;
	
	// load personal settings if allowed
	if($user_settings==1)
	{
		// check if user has personal settings
		$database->setQuery("SELECT count(user_id) FROM #__pms_conf WHERE user_id=$my_id");
		if(!$database->query()) pms_sql_error($database->getErrorMsg());
		$total = $database->loadResult();
		
		// if not create new record with default values
		if($total==0)
		{
			$database->setQuery("INSERT INTO #__pms_conf (user_id, email_new, email_reply, email_html, email_offline, email_sender_address, rows_per_page, pages_in_list, format_reply, clear_sent_items, popup, sound, sound_value) VALUES ($my_id, $email_new, $email_reply, $email_html, $email_offline, $email_sender_address, $rows_per_page, $pages_in_list, $format_reply, $clear_sent_items, $popup, $sound, $sound_value)");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
		}
		else
		{
			// override default values with personal ones
			$database->setQuery("SELECT * FROM #__pms_conf WHERE user_id=$my_id");
			if(!$database->query()) pms_sql_error($database->getErrorMsg());
			$rows = $database->loadObjectList();
			$row = $rows[0];

			if($allow_change_email_new==1) $email_new = $row->email_new;
			if($allow_change_email_reply==1) $email_reply = $row->email_reply;
			if($allow_change_email_html==1) $email_html = $row->email_html;
			if($allow_change_email_offline==1) $email_offline = $row->email_offline;
			if($allow_change_email_sender_address==1) $email_sender_address = $row->email_sender_address;
			if($allow_change_rows_per_page==1) $rows_per_page = $row->rows_per_page;
			if($allow_change_pages_in_list==1) $pages_in_list = $row->pages_in_list;
			if($allow_change_format_reply==1) $format_reply = $row->format_reply;
			if($allow_change_clear_sent_items==1) $clear_sent_items = $row->clear_sent_items;
			if($allow_change_popup==1) $popup = $row->popup;
			if($allow_change_sound==1) $sound = $row->sound;
			if($allow_change_sound_value==1) $sound_value = $row->sound_value;
		}
	}

	// check number of PMs in inbox, sent items and trash
	$database->setQuery("SELECT count(t1.id) FROM #__pms AS t1, #__users AS t2 WHERE t1.recip_id=$my_id AND inbox=1 AND t1.sender_id=t2.id");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$pm_in_inbox = $database->loadResult();
	
	$database->setQuery("SELECT count(t1.id) FROM #__pms AS t1, #__users AS t2 WHERE t1.sender_id=$my_id AND sent_items=1 AND t1.recip_id=t2.id");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$pm_in_sent_items = $database->loadResult();
	
	$database->setQuery("SELECT count(t1.id) FROM #__pms AS t1, #__users AS t2 WHERE (t1.recip_id=$my_id AND t1.inbox=0 AND t1.sender_id=t2.id) OR (t1.sender_id=$my_id AND t1.sent_items=0 AND t1.recip_id=t2.id)");
	if(!$database->query()) pms_sql_error($database->getErrorMsg());
	$pm_in_trash = $database->loadResult();
	
	$pm_all = $pm_in_inbox + $pm_in_sent_items + $pm_in_trash;
?>
	<script language="JavaScript" src="components/com_pms/functions.js" type="text/javascript"></script>
<?php
	// output of statusbar if limitation of PMs is enabled
	if($max_allowed_pm>0)
	{
		include_once(PMS_BASEPATH_COMPONENTS . '/limitationbar.php');
	}

	// output of menu
	include_once(PMS_BASEPATH_COMPONENTS . '/mainmenu.php');
	
	// needed page is included
	$page = mosGetParam($_GET, 'page');
	$page = $database->getEscaped($page);
	if(!$page) $page = "inbox";
	if($page=="open") include_once(PMS_BASEPATH_COMPONENTS . '/open.php');
	elseif($page=="inbox" OR $page=="sent_items" OR $page=="trash") include_once(PMS_BASEPATH_COMPONENTS . '/list.php');
	elseif($page=="new" OR $page=="reply" OR $page=="forward") include_once(PMS_BASEPATH_COMPONENTS . '/write.php');
	elseif($page=="search") include_once(PMS_BASEPATH_COMPONENTS . '/search.php');
	elseif($page=="addressbook") include_once(PMS_BASEPATH_COMPONENTS . '/addressbook.php');
	elseif($page=="ignore") include_once(PMS_BASEPATH_COMPONENTS . '/ignore.php');
	elseif($page=="settings") include_once(PMS_BASEPATH_COMPONENTS . '/settings.php');
	else include_once(PMS_BASEPATH_COMPONENTS . '/list.php');
}
?>