<?php
define( '_VALID_MOS', 1 );
require("configuration.php");
require("./includes/database.php");

$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );

$step1 = false;
$step2 = false;
$step3 = false;
$step4 = false;

$german = array();
$german[0] = 'PMS enhanced Version 2.0';
$german[1] = 'Vorbereitung fr Import bestehender Daten';
$german[2] = 'Schritt';
$german[3] = 'Backup der bestehenden Tabellen erstellt?';
$german[4] = 'alte Version deinstalliert?';
$german[5] = 'neue Version installiert?';
$german[6] = 'alte Daten in neue Tabellen importiert?';
$german[7] = '<span style="color:green;font-weight:bold;">JA</span>';
$german[8] = '<span style="color:red;font-weight:bold;">NEIN</span>';
$german[9] = '<input type="submit" name="backup" value="Backup erstellen" />';
$german[10] = '<input type="submit" value="erneut prfen" />';
$german[11] = '<input type="submit" name="import" value="Daten importieren" />';
$german[12] = '<span style="color:green;font-weight:bold;">Glckwunsch! Der Import ist erfolgreich beendet.</span>';
$german[13] = '<span style="color:red;font-weight:bold;">ACHTUNG! %s von %s Nachrichten konnten nicht importiert werden.</span>';

$english = array();
$english[0] = 'PMS enhanced Version 2.0';
$english[1] = 'preparation for import of existing data';
$english[2] = 'Step';
$english[3] = 'backup of current tables created?';
$english[4] = 'old version uninstalled?';
$english[5] = 'new version installed?';
$english[6] = 'old data in new tables imported?';
$english[7] = '<span style="color:green;font-weight:bold;">YES</span>';
$english[8] = '<span style="color:red;font-weight:bold;">NO</span>';
$english[9] = '<input type="submit" name="backup" value="create backup" />';
$english[10] = '<input type="submit" value="check again" />';
$english[11] = '<input type="submit" name="import" value="import data" />';
$english[12] = '<span style="color:green;font-weight:bold;">Congratulation! Import is completed successfully.</span>';
$english[13] = '<span style="color:red;font-weight:bold;">ATTENTION! %s of %s messages couldn\'t be imported.</span>';

if($mosConfig_lang=='germani' OR $mosConfig_lang=='german') $language = $german;
else $language = $english;

// correct step1
if(isset($_POST['backup']))
{
	$database->setQuery("CREATE TABLE #__pms_temp SELECT * FROM #__pms");
	if(!$database->query()) echo "<script>alert('".$database->getErrorMsg()."');</script>";
	$database->setQuery("CREATE TABLE #__pms_conf_temp SELECT * FROM #__pms_conf");
	if(!$database->query()) echo "<script>alert('".$database->getErrorMsg()."');</script>";
}

// correct step4
if(isset($_POST['import']))
{
	$step4 = true;
	
	// set index to old pms-table to reduce problems with system of >1000 PMs
	$database->setQuery("ALTER TABLE `#__pms_temp` ADD INDEX username (username), ADD INDEX whofrom (whofrom), ADD INDEX readstate (readstate)");
	if(!$database->query())
	{
		echo "<script>alert('".$database->getErrorMsg()."');</script>";
		$step4 = false;
	}
	
	// set username to 'messagebot' to all PMs where username is not known in the users table of the temp-table
	else
	{
		$database->setQuery("UPDATE #__pms_temp AS t1, #__users AS t2 SET t1.whofrom='messagebot' WHERE t1.whofrom!=t2.username");
		if(!$database->query())
		{
			echo "<script>alert('".$database->getErrorMsg()."');</script>";
			$step4 = false;
		}
		
		// import old PMs to new table
		else
		{
			$database->setQuery("INSERT IGNORE INTO #__pms (id, recip_id, sender_id, date, time, readstate, subject, message, inbox, sent_items) SELECT t3.id, t1.id, t2.id, t3.date, t3.time, t3.readstate, t3.subject, t3.message, t3.inbox, t3.sent_items FROM #__users AS t1, #__users AS t2, #__pms_temp AS t3 WHERE t1.username=t3.username AND t2.username=t3.whofrom");
			if(!$database->query())
			{
				echo "<script>alert('".$database->getErrorMsg()."');</script>";
				$step4 = false;
			}
		}
	}

	// check how many rows can't be imported
	$database->setQuery("SELECT count(id) FROM #__pms");
	$count_new = $database->loadResult();
	$database->setQuery("SELECT count(id) FROM #__pms_temp");
	$count_old = $database->loadResult();

	// import old user confs to new table
	if($step4)
	{
		$database->setQuery("INSERT IGNORE INTO #__pms_conf (id, user_id, email_new, email_reply, email_html, email_offline, format_reply, rows_per_page, pages_in_list) SELECT id, user_id, email_new, email_reply, email_html, email_offline, format_reply, rows_per_page, pages_in_list FROM #__pms_conf_temp");
		if(!$database->query())
		{
			echo "<script>alert('".$database->getErrorMsg()."');</script>";
			$step4 = false;
		}
	}

	// delete old temporary tables
	if($step4)
	{
		$database->setQuery("DROP TABLE #__pms_temp");
		if(!$database->query())
		{
			echo "<script>alert('".$database->getErrorMsg()."');</script>";
			$step4 = false;
		}
		$database->setQuery("DROP TABLE #__pms_conf_temp");
		if(!$database->query())
		{
			echo "<script>alert('".$database->getErrorMsg()."');</script>";
			$step4 = false;
		}
	}

	// correct old readstate 2 to 3 in new version
	if($step4)
	{
		$database->setQuery("UPDATE #__pms SET readstate=3 WHERE readstate=2");
		if(!$database->query())
		{
			echo "<script>alert('".$database->getErrorMsg()."');</script>";
			$step4 = false;
		}
	}
}

$database->setQuery("SHOW TABLES");
$tables = $database->loadResultArray();

// check if step1 is already done
if((in_array($mosConfig_dbprefix.'pms_temp', $tables, true) AND in_array($mosConfig_dbprefix.'pms_conf_temp', $tables, true)) OR in_array($mosConfig_dbprefix.'pms_addressbook', $tables, true)) $step1 = true;

// check if step2 is already done
if(!is_file('./components/com_pms/list_pms.php')) $step2 = true;

// check if step3 is already done
if(is_file('./components/com_pms/list.php')) $step3 = true;

?>

<form action="upgrade_to_version2.php" method="post">
<center>
<h3><?php echo $language[0]; ?><br /><?php echo $language[1]; ?></h3>
<table cellspacing="4" cellpadding="0" border="0">
<tr>
	<td>
		<b><?php echo $language[2]; ?> 1:</b>
	</td>
	<td>
		<?php echo $language[3]; ?><br />
	</td>
	<td>
	<?php
	if($step1) echo $language[7];
	else echo $language[8].$language[9];
	?>
	</td>
</tr>
<?php
if($step1)
{
?>
<tr>
	<td>
		<b><?php echo $language[2]; ?> 2:</b>
	</td>
	<td>
		<?php echo $language[4]; ?><br />
	</td>
	<td>
	<?php
	if($step2) echo $language[7];
	else echo $language[8].$language[10];
	?>
	</td>
</tr>
<?php
}
if($step1 AND $step2)
{
?>
<tr>
	<td>
		<b><?php echo $language[2]; ?> 3:</b>
	</td>
	<td>
		<?php echo $language[5]; ?><br />
	</td>
	<td>
	<?php
	if($step3) echo $language[7];
	else echo $language[8].$language[10];
	?>
	</td>
</tr>
<?php
}
if($step1 AND $step2 AND $step3)
{
?>
<tr>
	<td>
		<b><?php echo $language[2]; ?> 4:</b>
	</td>
	<td>
		<?php echo $language[6]; ?><br />
	</td>
	<td>
	<?php
	if($step4) echo $language[7];
	else echo $language[8].$language[11];
	?>
	</td>
</tr>
<?php
}
?>
</table>
</form>
<?php
if($step1 AND $step2 AND $step3 AND $step4) echo '<br />'.$language[12];
if($count_new<$count_old)
{
	$difference = $count_old - $count_new;
	echo '<br />'.sprintf($language[13], $difference, $count_old);
}

?>